/*

Politecnico di Torino - Fondamenti di Informatica (06AZN)

una possibile soluzione del tema d'esame del 26/6/2014
[ completa con molti controlli ]

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// porre ad uno se si desiderano i messaggi di debug, a zero altrimenti
#define DEBUG 1


#define NP 13
#define MAXBUFLEN 255
#define UNO '1'
#define ICS 'X'
#define DUE '2'
#define FRIS_NAME "risultati.txt"


FILE *my_fopen (char *fname, char *fmode)
{
   FILE *fp = fopen (fname, fmode);
   if (fp ==NULL)
   {
      fprintf (stderr, "errore - impossibile aprire il file %s in modo %s\n",
         fname, fmode);
      exit (1);
   }
   return fp;
}

void my_fclose (FILE *fp, char *fname)
{
   if (fclose (fp) != 0)
   {
      fprintf (stderr, "avviso - fallita chiusura del file %s (potrebbe essere dannegiato o inaccessibile)\n", fname);
   }
}


int main (int argc, char *argv[])
{
  FILE *fris;
  FILE *fsch;
  char buf[MAXBUFLEN+1];
  int i, g1, g2;
  int ris;
  int ngiusti = 0;
  int npronostici;

  if (argc != 2) {
     fprintf (stderr, "errore - usage: %s nome_file_schedina\n", argv[0]);
     return 1;
  }

  fsch = my_fopen (argv[1], "r");

  fris = my_fopen (FRIS_NAME, "r");

  for (i=1; i<=NP; i++) 
  {
     // lettura riga partita i-esima
     if (fgets (buf, MAXBUFLEN, fris) == NULL)
     {
        fprintf (stderr, "errore - manca la riga della partita n.%d\n", i);
        return 1;
     }

     // lettura goal partita i-esima
     if (sscanf (buf, "%*s %*s %d %d", &g1, &g2) != 2)
     {
        fprintf (stderr, "errore - formato della partita n.%d errato\n", i);
        return 1;
     }

     // calcolo risultato 1 X 2
     if (g1 > g2)
        ris = UNO;
     else if (g1 < g2)
        ris = DUE;
     else // g1 == g2
        ris = ICS;

#if DEBUG
     printf ("risultato partita n.%d = %c\n", i, ris);
#endif

     // lettura riga pronostico i-esimo
     if (fgets (buf, MAXBUFLEN, fsch) == NULL)
     {
        fprintf (stderr, "errore - manca la riga del pronostico n.%d\n", i);
        return 1;
     }
     // cancellazione del \n finale
     buf[ strlen(buf)-1 ] = '\0';

#if DEBUG
     printf ("pronostico partita n.%d = %s\n", i, buf);
#endif

     // controllo che sia stata giocata una singola, doppia o tripla
     npronostici = strlen (buf);
     if (npronostici<1 || npronostici>3)
     {
        fprintf (stderr, "errore - lunghezza del pronostico n.%d errata (%d)\n", i, npronostici);
        return 1;
     }

     // verifico se il risultato compare all'interno del pronostico
     if (strchr(buf,ris) != NULL)
     {
        ngiusti++;
#if DEBUG
        printf ("pronostico azzeccato\n\n");
     }
     else
     {
        printf ("pronostico sbagliato\n\n");
#endif
     }
  }

  printf ("azzeccati %d pronostici\n", ngiusti);

  my_fclose (fris, FRIS_NAME);
  my_fclose (fsch, argv[1]);

  return 0;
}
